/*
 * This file is part of the ESPDA Pipeline
 * Copyright (C) 2002,2003 European Southern Observatory
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

/*
 * $Id: espda_fit.h 161538 2014-05-22 13:56:10Z gcupani $
 * $Author: gcupani $
 * $Date: 2014-05-22 15:56:10 +0200 (Thu, 22 May 2014) $
 * $Revision: 161538 $
 */

#ifndef ESPDA_FIT_H
#define ESPDA_FIT_H

/*-----------------------------------------------------------------------------
                                   Includes
 -----------------------------------------------------------------------------*/

#include <cpl.h>
#include <gsl/gsl_blas.h>
#include <gsl/gsl_multifit_nlin.h>
//#include <gsl/gsl_multifit_nlinear.h>
//#include <gsl/gsl_multilarge_nlinear.h>
#include <gsl/gsl_spline.h>
#include <time.h>

#include "espda_dfs.h"
#include "espda_line.h"
#include "espda_model.h"
#include "espda_print.h"
#include "espda_split.h"
#include "espda_struct.h"
#include "espda_voigt.h"
//#include "sgfilter.h"

/*-----------------------------------------------------------------------------
                                   Defines
 -----------------------------------------------------------------------------*/

#define RCHISQ pow(gsl_blas_dnrm2(solver->f), 2.0) / (double)dof

/*-----------------------------------------------------------------------------
                                       Prototypes
 -----------------------------------------------------------------------------*/

cpl_error_code espda_fit_cspline(cpl_table  *,
                                 char       *,
                                 cpl_table  *,
                                 cpl_table  *);
/*
cpl_table     *espda_fit_sg     (cpl_table  *,
                                 char       *,
				 int);
*/
/*
void          *espda_fit_callback(const size_t,
				  void       *,
				  const gsl_multifit_nlinear_workspace *);
*/
cpl_error_code espda_fit_voigt(cpl_table  *,
                               cpl_table  *,
                               cpl_table  *,
                               cpl_table  *,
                               cpl_table  *,
                               cpl_table  *,
                               cpl_array  *,
                               cpl_array  *,
                               cpl_size,
                               cpl_table **,
                               cpl_table **);

#endif
