/* $Id: espda_split.h 172371 2015-04-15 14:37:33Z gcupani $
 *
 * This file is part of the ESPDA Pipeline
 * Copyright (C) 2002,2003 European Southern Observatory
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
 */

/*
 * $Author: gcupani $
 * $Date: 2015-04-15 16:37:33 +0200 (Wed, 15 Apr 2015) $
 * $Revision: 172371 $
 * $Name:  $
 */

#ifndef ESPDA_SPLIT_H
#define ESPDA_SPLIT_H

/*-----------------------------------------------------------------------------
                                   Includes
 -----------------------------------------------------------------------------*/

#include <cpl.h>

#include "espda_dfs.h"
#include "espda_print.h"

/*-----------------------------------------------------------------------------
                                   Functions prototypes
 -----------------------------------------------------------------------------*/

cpl_error_code espda_split_group(cpl_table     *,
                                 cpl_table     *,
                                 cpl_table     *,
                                 int,
                                 cpl_array    **,
                                 cpl_table    **,
                                 cpl_table    **,
                                 cpl_table    **);

cpl_error_code espda_split_chunk(cpl_table     *,
                                 cpl_table     *,
                                 cpl_table     *,
                                 char          *,
                                 cpl_table    **,
                                 cpl_table    **,
                                 cpl_table    **);

cpl_error_code espda_split_part (cpl_table     *,
                                 double,
                                 double,
                                 cpl_table    **,
                                 cpl_table    **);

#endif
